/*-
 * Copyright (c) 1999, 2000 MAEKAWA Masahide <maekawa@math.sci.kobe-u.ac.jp>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	$Maekawa: audio.h,v 1.6 2000/03/19 16:14:43 maekawa Exp $
 */
	
/*
 * Class: Audio
 */

void audio_interface			__P((usb_descriptor_t *, u_int16_t));
void audio_endpoint			__P((usb_descriptor_t *, u_int16_t));

/*
 * SubClass: Audio Control
 */
void audio_control_interface		__P((usb_descriptor_t *));
void audio_control_header		__P((u_int8_t *));
void audio_control_input_terminal	__P((u_int8_t *));
void audio_control_output_terminal	__P((u_int8_t *));
void audio_control_mixer_unit		__P((u_int8_t *));
void audio_control_selector_unit	__P((u_int8_t *));
void audio_control_feature_unit		__P((u_int8_t *));
void audio_control_processing_unit	__P((u_int8_t *));
void audio_control_extension_unit	__P((u_int8_t *));

/*
 * SubClass: Audio Streaming
 */
void audio_streaming_interface		__P((usb_descriptor_t *));
void audio_streaming_endpoint		__P((usb_descriptor_t *));
void audio_streaming_general		__P((u_int8_t *));
void audio_streaming_format		__P((u_int8_t *));
void audio_streaming_format_type1	__P((u_int8_t *));
void audio_streaming_format_type2	__P((u_int8_t *));
void audio_streaming_format_type3	__P((u_int8_t *));
void audio_streaming_format_specific	__P((u_int8_t *));
void audio_streaming_format_mpeg	__P((u_int8_t *));
void audio_streaming_format_ac3		__P((u_int8_t *));

/*
 * SubClass: MIDI Streaming
 */
void audio_midi_interface		__P((usb_descriptor_t *));
void audio_midi_endpoint		__P((usb_descriptor_t *));
void audio_midi_header			__P((u_int8_t *));
void audio_midi_midi_in_jack		__P((u_int8_t *));
void audio_midi_midi_out_jack		__P((u_int8_t *));
void audio_midi_element			__P((u_int8_t *));
